%--------------------------------------------------------------------------
% Copyright(c) Zbancioc Marius-Dan, 2014, zmarius@etti.tuiasi.ro
% 1)Institute of Computer Science, Roumanian Academy, Iasi Branch, 
% 2)Technical University "Gheorghe Asachi" of Iasi, Romania
%--------------------------------------------------------------------------
% References:
%- M. Zbancioc, M. Feraru, The Analysis of the FCM and WKNN Algorithms Performance for the Emotional Corpus SROL, Advances in Electrical and Computer Engineering, Vol. 12, Issue 3, 2012, pp. 33  38, ISSN: 1582-7445, e-ISSN: 1844-7600, Digital Object Identifier: 10.4316/AECE.2012.03005
%- M. Feraru, M. Zbancioc, Speech Emotion Recognition for SROL Database using Weighted KNN algorithm, International Conference on Electronics, Computers and Artificial Intelligence (ECAI2013), June 27-29, 2013, Pitesti, Romania, ISBN: 978-1-4673-4935-2, Digital Object Identifier: 10.1109/ECAI.2013.6636189 2013 IEEE
%- M. Zbancioc, M. Feraru, A Study about MFCC Relevance in Emotion Classification for SROL Database, Proceedings of 4th International Symposium on Electrical and Electronics Engineering, ISEEE 2013, October, 11-13, 2013, Gala?i, Romnia, ISBN 978-1-4799-2441-7, IEEE Catalog Number CFP1393K-USB.
%- M. Zbancioc, M. Feraru, Using the Lyapunov Exponent from Cepstral Coefficients for Automatic Emotion Recognition, Proc of 8th IEEE International Conference on Electrical and Power Engineering  EPE 2014, 16-17 Oct., Ia?i, Romnia, ISSN: 978-1-4799-5848-1.
%- M. Feraru, M. Zbancioc, Emotion Recognition in Romanian Language using LPC Features, The 4th IEEE International Conference on E-Health and Bioengineering - EHB 2013, November 21-23, 2013, Ia?i, Romania, ISBN: 978-1-4799-2373-1/13/$31.00 2013 IEEE

path = {'E:\IPA_sounds_selection\DB100\bucurie\feminin\',...
        'E:\IPA_sounds_selection\DB100\bucurie\masculin\',...
        'E:\IPA_sounds_selection\DB100\furie\feminin\',...
        'E:\IPA_sounds_selection\DB100\furie\masculin\',...
        'E:\IPA_sounds_selection\DB100\tristete\feminin\',...
        'E:\IPA_sounds_selection\DB100\tristete\masculin\',...
        'E:\IPA_sounds_selection\DB100\neutru\feminin\',...
        'E:\IPA_sounds_selection\DB100\neutru\masculin\'};
    
path = {'E:\IPA_sounds_selection\DB100\__Testare\'};
calcul_MFCC=1;
calcul_LPCC=1;
    
emotion_ID=char(zeros(8,2));
warning('off');%,'stats:nlinfit:IterationLimitExceeded');
if calcul_MFCC==1,
for i=1:length(path)
    %list=dir([path{i} 'MFCC\' '*.mfcc');
    list=dir([path{i} 'MFCC\' '*.mat']);
    %poz_backslash=find(path{i}=='\'); emotion_ID(i,:)=[path{i}(poz_backslash(end-2)+1) path{i}(poz_backslash(end-1)+1)];
    for j = 1: length(list)
        load([path{i} 'MFCC\' list(j).name]);
        disp(sprintf('%d - %s',j,list(j).name));
        
        if exist([path{i} 'MFCC\' list(j).name(1:end-3) 'lyap'])==0
            disp('MFCC');
            lyap = zeros(12,3); vLLE = zeros(12,10,10);
            for k = 1:12 %size(vMFCC,2)
                %[LLE,tau,m,lambda] = lyaprosen(vMFCC(:,k)',0,0,0);
                 for tau = 1 : 10
                    for m = 1 : 10
                        %fprintf('tau:%d m:%d\n',tau,m);
                        vLLE(k,tau,m) = lyaprosen(vMFCC(:,k)',tau,m,0);
                    end
                    fprintf(1,'.');
                end
                LLE = max(max(vLLE(k,:,:) ));
                poz = find(vLLE(k,:,:) == LLE);
                m = ceil(poz/10); tau = poz-(m-1)*10;
                lyap(k,:) = [LLE, tau, m];
                disp(sprintf('tau:%2d | m:%2d | LLE:%6.3f',tau,m,LLE ));
            end
            %Save the Lyapunov values in files with extension *.lyap
            fid_lyap = fopen([path{i} 'MFCC\' list(j).name(1:end-3) 'lyap'],'w');
            for k = 1 : 12
                fprintf(fid_lyap ,'%2d, %2d, %.6g\r\n', lyap(k,2), lyap(k,3), lyap(k,1));
            end
            fclose(fid_lyap);
            save([path{i} 'MFCC\' list(j).name], 'vMFCC', 'lyap', 'vLLE');
        end
    end
end
end
% Extract Lypunov from LPCC 
if calcul_LPCC==1
for i=1:length(path)
    %list=dir([path{i} 'LPCC\' '*.mfcc');
    list=dir([path{i} 'LPCC\' '*.mat']);
    %poz_backslash=find(path{i}=='\'); emotion_ID(i,:)=[path{i}(poz_backslash(end-2)+1) path{i}(poz_backslash(end-1)+1)];
    for j = 1: length(list)
        load([path{i} 'LPCC\' list(j).name]);
        disp(sprintf('%d - %s',j,list(j).name));
        if exist([path{i} 'LPCC\' list(j).name(1:end-3) 'lyap'])==0
            disp('LPCC');
            lyap = zeros(21,3); vLLE = zeros(21,10,10);
            for k = 1:21 %size(vLPCC,2)
                %[LLE,tau,m,lambda] = lyaprosen(vLPCC(:,k)',0,0,0);
                for tau = 1 : 10
                    for m = 1 : 10
                        vLLE(k,tau,m) = lyaprosen(vLPCC(:,k)',tau,m,0);
                        %when the interval of values with maxim=1 or minim -1, is growed of 100 times; the Lyapunov computing is not affected
                        %v = vLPCC(:,k)'; v=v/max(abs(max(v)),abs(min(v)))*100; 
                        %vLLE(k,tau,m) = lyaprosen(v,tau,m,0);
                        %disp(sprintf('tau:%d , m:%d',tau,m));
                    end
                    fprintf(1,'.');
                end
                LLE = max(max(vLLE(k,:,:) ));
                poz = find(vLLE(k,:,:) == LLE);
                m = ceil(poz/10); tau = poz-(m-1)*10;
                lyap(k,:) = [LLE, tau, m];
                disp(sprintf('tau:%d | m:%d | LLE:%f',tau,m,LLE ));
            end
            %Save the Lyapunov values in files with extension *.lyap
            fid_lyap = fopen([path{i} 'LPCC\' list(j).name(1:end-3) 'lyap'],'w');
            for k = 1 : 21
                fprintf(fid_lyap ,'%2d, %2d, %.6g\r\n', lyap(k,2), lyap(k,3), lyap(k,1));
                fprintf(fid_lyap ,'\r\n');
            end
            fclose(fid_lyap);
            save([path{i} 'LPCC\' list(j).name], 'vLPCC', 'lyap', 'vLLE');
        
           disp(sprintf('---------------------------------'));
        end
    end
end
end